SystemOrganization addCategory: #AuDSL3!
SystemOrganization addCategory: #'AuDSL3-Examples'!
SystemOrganization addCategory: #'AuDSL3-Tests'!

TestCase subclass: #Au3CompilerTestcase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3CompilerTestcase methodsFor: 'as yet unclassified' stamp: 'hk 5/19/2010 20:07'!
setUp

! !

!Au3CompilerTestcase methodsFor: 'as yet unclassified' stamp: 'Hartmut Krasemann 8/5/2010 12:14'!
testCompileAu3MicrowaveOven
	| result |
	result := Au3Compiler compile: (Au3MicrowaveOven basicNew ovenSpec).
	self should: [result isKindOf: Au3State]! !

!Au3CompilerTestcase methodsFor: 'as yet unclassified' stamp: 'Hartmut Krasemann 8/5/2010 12:13'!
testCompileTestMachine1
	| result  |
	result := Au3Compiler compile: (Au3TestMachine1 basicNew testSpec).
	self should: [result isXor].
	self should: [result children size =2]! !

!Au3CompilerTestcase methodsFor: 'as yet unclassified' stamp: 'Hartmut Krasemann 8/5/2010 12:13'!
testCompileTestMachine2
	| result |
	result := Au3Compiler compile: (Au3TestMachine2 basicNew testSpec).
	self should: [result isKindOf: Au3XorState]! !

TestCase subclass: #Au3MicrowaveOvenTestcase
	instanceVariableNames: 'app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3MicrowaveOvenTestcase methodsFor: 'running' stamp: 'hk 7/16/2010 09:40'!
setUp
	
	app := Au3MicrowaveOven new! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'hk 7/6/2010 19:50'!
testClose

	app  openDoor; closeDoor. 
	self should: [ (app oven at: 'cooking') isEntered not].
	self should: [ (app oven at: 'idle') isEntered ].
	self should: [ (app oven at: 'closed') isEntered].
	self should: [ (app oven at: 'open') isEntered not]
! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'hk 7/6/2010 19:50'!
testFinish

	app  closeDoor; start; finish. 
	self should: [ (app oven at: 'cooking') isEntered not ].
	self should: [ (app oven at: 'idle') isEntered ].
	self should: [ (app oven at: 'open') isEntered not].
	self should: [ (app oven at: 'closed') isEntered]

! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'hk 7/15/2010 19:06'!
testHistory

	app closeDoor.
	app oven  exit.
	self should: [ (app oven at: 'cooking') isEntered not ].
	self should: [ (app oven at: 'idle') isEntered not ].
	self should: [ (app oven at: 'idle') isEntered not ].
	self should: [ (app oven at: 'heater') isEntered not ].
	self should: [ (app oven at: 'door') isEntered not ].
	self should: [ (app oven at: 'closed') isEntered not].
	self should: [ (app oven at: 'open') isEntered not].
	self should: [ (app oven at: 'door') historyChild = (app oven at: 'closed')].
	
! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'Hartmut Krasemann 7/30/2010 15:12'!
testInit

	self should: [ (app oven at: 'cooking') isEntered not ].
	self should: [ (app oven at: 'idle') isEntered ].
	self should: [ (app oven at: 'closed') isEntered ].
	self should: [ (app oven at: 'open') isEntered not]
! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'hk 5/12/2010 18:01'!
testSetTime1

	app  closeDoor; setTime: 10. 
	self testStart

! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'hk 5/12/2010 18:01'!
testSetTime2

	app  openDoor; setTime: 10. 
	self testStart

! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'hk 7/6/2010 19:51'!
testStart

	app  closeDoor; start. 
	self should: [ (app oven at: 'cooking') isEntered ].
	self should: [ (app oven at: 'idle') isEntered not ].
	self should: [ (app oven at: 'closed') isEntered].
	self should: [ (app oven at: 'open') isEntered not]
! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'hk 7/6/2010 19:51'!
testStartAndOpenDoor

	app  start; openDoor. 
	self should: [ (app oven at: 'cooking') isEntered not ].
	self should: [ (app oven at: 'idle') isEntered ].
	self should: [ (app oven at: 'open') isEntered].
	self should: [ (app oven at: 'closed') isEntered not]

! !

!Au3MicrowaveOvenTestcase methodsFor: 'tests' stamp: 'hk 7/6/2010 19:51'!
testStartonOpenDoor

	app  openDoor; start. 
	self should: [ (app oven at: 'cooking')  isEntered not ].
	self should: [ (app oven at: 'idle') isEntered ].
	self should: [ (app oven at: 'open') isEntered].
	self should: [ (app oven at: 'closed') isEntered not]

! !

TestCase subclass: #Au3TestMachine1Testcase
	instanceVariableNames: 'app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 6/28/2010 12:26'!
setUp
	
	app := Au3TestMachine1 new.
! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'Hartmut Krasemann 8/5/2010 12:14'!
testCompileTestMachine
	| result |
	result := Au3Compiler compile: (Au3TestMachine1  basicNew testSpec).
	self should: [result isKindOf: Au3XorState]! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 7/16/2010 09:56'!
testComplexMultiTransition
	"leaving and entering states correctly"
	(app root) enter.
	self should: [ app root isEntered ].
	self should: [ (app root at: 'top1') isEntered ].
	self should: [ (app root at: 'top2') isEntered not].
	(app root) process: #aa.
	self should: [ (app root at: 'top1') isEntered ].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top1x2') isEntered ].
	(app root) process: #gg.
	self should: [ (app root at: 'top1') isEntered not].
	self should: [ (app root at: 'top2') isEntered ].
	self should: [ (app root at: 'top2x2') isEntered ].
	self should: [ (app root at: 'top2x2x1') isEntered].
	(app root) process: #ee.
	self should: [ (app root at: 'top2x2x2') isEntered].
	(app root) process: #ff.
	self should: [ (app root at: 'top1x2') isEntered ].
	self should: [ app root isEntered ].
	self should: [ (app root at: 'top1') isEntered ].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top1x1') isEntered not].
	self should: [ (app root at: 'top2x1') isEntered not].
	self should: [ (app root at: 'top2x2x1') isEntered not].
	self should: [ (app root at: 'top1x2') isEntered ].
	self should: [ (app root at: 'top2x2') isEntered not].
	self should: [ (app root at: 'top2x2x2') isEntered not]


! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 7/16/2010 09:53'!
testComplexTransition

	(app root) enter.
	(app root) process: #bb.
	self should: [ app root isEntered ].
	self should: [ (app root at: 'top1') isEntered not].
	self should: [ (app root at: 'top1x1') isEntered not].
	self should: [ (app root at: 'top1x2') isEntered not].
	self should: [ (app root at: 'top2') isEntered].
	self should: [ (app root at: 'top2x1') isEntered ].
	self should: [ (app root at: 'top2x2') isEntered not].
	self should: [ (app root at: 'top2x2x1') isEntered not].
	self should: [ (app root at: 'top2x2x2') isEntered not]! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 7/16/2010 09:55'!
testEntryExitActions
	"and a transitin deep in hierarchy"
	(app root) enter.
	self should: [ app root isEntered ].
	(app root) process: #aa.
	self should: [ (app root at: 'top1x2') isEntered].
	self should: [ (app action1x2 = true)].
	(app root) process: #gg.
	self should: [ app root isEntered ].
	self should: [ (app root at: 'top1') isEntered not].
	self should: [ (app root at: 'top2') isEntered].
	self should: [ (app root at: 'top1x1') isEntered not].
	self should: [ (app root at: 'top2x1') isEntered not].
	self should: [ (app root at: 'top2x2x1') isEntered ].
	self should: [ (app root at: 'top1x2') isEntered not].
	self should: [ (app action1x2 = false)].
	self should: [ (app root at: 'top2x2') isEntered ].
	self should: [ (app root at: 'top2x2x2') isEntered not]


! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'Hartmut Krasemann 8/4/2010 15:42'!
testEventActions

	(app root) enter.
	(app root) process: #zz.
	self should: [ (app root at: 'top2') isEntered].
	self should: [ (app eventAction2) & (app eventAction1)].
! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 7/15/2010 19:14'!
testHistory

	app root enter.
	self should: [ (app root at: 'top1') isEntered ].
	self should: [ (app root at: 'top2') isEntered not].
	app root process: #aa.
	app root process: #gg.
	app root process: #ee.
	self should: [ (app root at: 'top1') isEntered not].
	self should: [ (app root at: 'top2') isEntered].
	self should: [ (app root at: 'top2x2x2') isEntered].
	app root process: #yy.
	self should: [ (app root at: 'top1') isEntered].
	self should: [ (app root at: 'top1x1') isEntered].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top2') historyChild = (app root at: 'top2x2')].
	self should: [ (app root at: 'top2x2') historyChild = (app root at: 'top2x2x2')].
	app root process: #zz.
	self should: [ app root isEntered ].
	self should: [ (app root at: 'top1') isEntered not].
	self should: [ (app root at: 'top2') isEntered].
	self should: [ (app root at: 'top2x1') isEntered not].
	self should: [ (app root at: 'top2x2') isEntered].
	self should: [ (app root at: 'top2x2x1') isEntered not].
	self should: [ (app root at: 'top2x2x2') isEntered]


! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'Hartmut Krasemann 8/4/2010 15:34'!
testInit

	self should: [ app root isEntered not].
	self should: [ (app action1x2 not)].
	self should: [ (app eventAction2 not)].
	self should: [ (app eventAction1 not)].
	self should: [ (app root at: 'top1') isEntered not].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top1x1') isEntered not].
	self should: [ (app root at: 'top2x1') isEntered not].
	self should: [ (app root at: 'top2x2x1') isEntered not].
	self should: [ (app root at: 'top1x2') isEntered not].
	self should: [ (app root at: 'top2x2') isEntered not].
	self should: [ (app root at: 'top2x2x2') isEntered not]


! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 7/16/2010 09:42'!
testJumpIntoHistory

	(app root) enter.
	self should: [ (app root at: 'root') isEntered].
	self should: [ (app root at: 'top1') isEntered].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top1x1') isEntered].
	app root process: #zz.
	self should: [ (app root at: 'top1') isEntered not].
	self should: [ (app root at: 'top2') isEntered].
	app root process: #cc.
	app root process: #ee.
	self should: [ (app root at: 'top2x1') isEntered not].
	self should: [ (app root at: 'top2x2x2') isEntered].
	app root process: #yy.
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top1x1') isEntered].
	app root process: #bb.
	self should: [ (app root at: 'top1') isEntered not].
	self should: [ (app root at: 'top2') isEntered].
	self should: [ (app root at: 'top2x1') isEntered].
	self should: [ (app root at: 'top2x2') isEntered not].
	self should: [ (app root at: 'top2x2x2') isEntered not].
! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 7/15/2010 12:32'!
testNoHistory

	app root enter.
	self should: [ (app root at: 'top1') isEntered ].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top1x1') isEntered].
	app root process: #aa.
	self should: [ (app root at: 'top1x2') isEntered].
	self should: [ (app root at: 'top2') isEntered not].
	app root process: #zz.
	app root process: #yy.
	self should: [ app root isEntered ].
	self should: [ (app root at: 'top1') isEntered].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top1x2') isEntered not].
	self should: [ (app root at: 'top1x1') isEntered].


! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 7/6/2010 16:00'!
testStart

	(app root) enter.
	self should: [ (app root) isEntered ].
	self should: [ (app root at: 'top1') isEntered].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top1x1') isEntered].
	self should: [ (app root at: 'top2x1') isEntered not].
	self should: [ (app root at: 'top2x2x1') isEntered not].
	self should: [ (app root at: 'top1x2') isEntered not].
	self should: [ (app root at: 'top2x2') isEntered not].
	self should: [ (app root at: 'top2x2x2') isEntered not]


! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 1/7/2014 11:52'!
testguardedTransition

	app root enter.
	app guard: false.
	app root process: #aa.
	self should: [ app root isEntered ].
	self should: [ (app root at: 'top1') isEntered].
	self should: [ (app root at: 'top1x1') isEntered ].
	self should: [ (app root at: 'top1x1') log includesSubstring: 'guards failed' ].
	self should: [ (app root at: 'top1x2') isEntered not].


! !

!Au3TestMachine1Testcase methodsFor: 'running' stamp: 'hk 7/16/2010 09:48'!
testsimpleTransition

	app root enter.
	app root process: #aa.
	self should: [ app root isEntered ].
	self should: [ (app root at: 'top1') isEntered].
	self should: [ (app root at: 'top1x2') isEntered].
	self should: [ (app root at: 'top1x1') isEntered not].
	self should: [ (app root at: 'top2') isEntered not].
	self should: [ (app root at: 'top2x1') isEntered not].
	self should: [ (app root at: 'top2x2') isEntered not].
	self should: [ (app root at: 'top2x2x1') isEntered not].
	self should: [ (app root at: 'top2x2x2') isEntered not]


! !

TestCase subclass: #Au3TestMachine2Testcase
	instanceVariableNames: 'app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3TestMachine2Testcase methodsFor: 'running' stamp: 'hk 6/28/2010 12:26'!
setUp
	
	app := Au3TestMachine2 new.
! !

!Au3TestMachine2Testcase methodsFor: 'running' stamp: 'hk 7/16/2010 10:05'!
testHistory

	app world enter.
	app world process: #aa.
	app world process: #c.
	app world process: #ee.
	self should: [ (app world at: 'root1') isEntered].
	self should: [ (app world at: 'root2') isEntered not].
	self should: [ (app world at: 'top1') isEntered].
	self should: [ (app world at: 'top1x1') isEntered not].
	self should: [ (app world at: 'top1x2') isEntered].
	self should: [ (app world at: 'top2') isEntered].
	self should: [ (app world at: 'top2x1') isEntered not].
	self should: [ (app world at: 'top2x2') isEntered].
	self should: [ (app world at: 'top2x2x2') isEntered].
	app world process: #zz.
	app world process: #xx.
	self should: [ (app world at: 'top1') isEntered].
	self should: [ (app world at: 'top2') isEntered].
	self should: [ (app world at: 'top1x1') isEntered ]. "here's no history"
	self should: [ (app world at: 'top1x2') isEntered not].
	self should: [ (app world at: 'top2x1') isEntered not].
	self should: [ (app world at: 'top2x2x2') isEntered]. "here's history"
! !

!Au3TestMachine2Testcase methodsFor: 'running' stamp: 'hk 7/16/2010 09:58'!
testInit

	self should: [ app world isEntered not].
	self should: [ (app world at: 'root1') isEntered not].
	self should: [ (app world at: 'root2') isEntered not].
	self should: [ (app world at: 'top1') isEntered not].
	self should: [ (app world at: 'top1x1') isEntered not].
	self should: [ (app world at: 'top1x2') isEntered not].
	self should: [ (app world at: 'top2') isEntered not].
	self should: [ (app world at: 'top2x1') isEntered not].
	self should: [ (app world at: 'top2x2') isEntered not].
	self should: [ (app world at: 'top2x2x1') isEntered not].
	self should: [ (app world at: 'top2x2x2') isEntered not]


! !

!Au3TestMachine2Testcase methodsFor: 'running' stamp: 'hk 7/23/2010 13:26'!
testMultiExit

	self testStart.
	self should: [ (app world at: 'top1') isEntered].
	self should: [ (app world at: 'top2') isEntered].
	self should: [ (app world at: 'top1x1') isEntered].
	self should: [ (app world at: 'top2x1') isEntered].
	app world process: #aa.
	self should: [ (app world at: 'top1x1') isEntered not].
	self should: [ (app world at: 'top1x2') isEntered].
	self should: [ (app world at: 'top2') isEntered].
	app world process: #zz.	
	self should: [ app world isEntered ].
	self should: [ (app world at: 'root1') isEntered not].
	self should: [ (app world at: 'root2') isEntered ].
	self should: [ (app world at: 'top1') isEntered not].
	self should: [ (app world at: 'top2') isEntered not].
	self should: [ (app world at: 'top1x1') isEntered not].
	self should: [ (app world at: 'top2x1') isEntered not].
	self should: [ (app world at: 'top2x2x1') isEntered not].
	self should: [ (app world at: 'top1x2') isEntered not].
	self should: [ (app world at: 'top2x2') isEntered not].
	self should: [ (app world at: 'top2x2x2') isEntered not]
! !

!Au3TestMachine2Testcase methodsFor: 'running' stamp: 'hk 7/16/2010 09:59'!
testStart

	self testInit.
	(app world) enter.
	self should: [ app world isEntered ].
	self should: [ (app world at: 'root1') isEntered ].
	self should: [ (app world at: 'root2') isEntered not].
	self should: [ (app world at: 'top1') isEntered].
	self should: [ (app world at: 'top1x1') isEntered].
	self should: [ (app world at: 'top1x2') isEntered not].
	self should: [ (app world at: 'top2') isEntered].
	self should: [ (app world at: 'top2x1') isEntered].
	self should: [ (app world at: 'top2x2') isEntered not].
	self should: [ (app world at: 'top2x2x1') isEntered not].
	self should: [ (app world at: 'top2x2x2') isEntered not]
! !

!Au3TestMachine2Testcase methodsFor: 'running' stamp: 'hk 7/23/2010 15:02'!
testandInspect
	"remove marks around inspect to inspect"
	self testStart.
	(app world) 
		process: #c;
		process: #ee;
		process: #a.
"	app world inspect."
	self should: [ (app world at: 'root1') isEntered].
	self should: [ (app world at: 'top1') isEntered].
	self should: [ (app world at: 'top1x1x2x1') isEntered].
	self should: [ (app world at: 'top1x1x1x2') isEntered].
	self should: [ (app world at: 'top2x2x2') isEntered].
	self should: [ (app world at: 'root2') isEntered not].
! !

TestCase subclass: #Au3TestMachine3Testcase
	instanceVariableNames: 'app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3TestMachine3Testcase methodsFor: 'running' stamp: 'hk 3/2/2012 12:33'!
setUp
	"setup must be done in test method since we catch DSL errors while parsing"! !

!Au3TestMachine3Testcase methodsFor: 'running' stamp: 'hk 1/7/2014 11:52'!
testTargetError
	"Au3TestMachine4 new"
	self should: [app := Au3TestMachine3 new] raise: Error withExceptionDo: 
		[:ex| self should: [(ex description includesSubstring: 'is unknown') 
						& (ex description includesSubstring: 'wrong1') 
						& (ex description includesSubstring: 'wrong2')] ]! !

!Au3TestMachine3Testcase methodsFor: 'running' stamp: 'hk 1/7/2014 11:53'!
testTransitionError
	"Au3TestMachine3 new"
	self should: [app := Au3TestMachine3 new] raise: Error withExceptionDo: 
		[:ex| self should: [(ex description includesSubstring: 'is illegal') 
						& (ex description includesSubstring: 'gg') 
						& (ex description includesSubstring: 'bb') 
						& (ex description includesSubstring: 'ff')
						& (ex description includesSubstring: 'yy')
						& (ex description includesSubstring: 'c')						
						] ] ! !

PPCompositeParser subclass: #Au3Grammar
	instanceVariableNames: 'identifier transition history onentry onexit state xortype regiontype actions guards comment sc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3'!

!Au3Grammar commentStamp: 'hk 5/19/2010 20:19' prior: 0!
I hold the AuDSL grammar rules without productions.
See superclass comment.!

Au3Grammar subclass: #Au3Compiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3'!

!Au3Compiler commentStamp: 'hk 5/19/2010 20:19' prior: 0!
I hold the productins of the AuDSL
!

!Au3Compiler methodsFor: 'productions' stamp: 'hk 1/7/2014 11:48'!
actions 
	^ super actions ==> [:nodes | nodes ifNil: [Array new] ifNotNil: [nodes second collect: [:g| g inputValue asSymbol ] ] ]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 1/7/2014 11:46'!
guards 
	^ super guards ==> [:nodes | nodes 	ifNil: [Array new]  ifNotNil: [nodes second  collect: [:g| g inputValue asSymbol ] ] ]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 3/9/2012 20:00'!
history
	^ super history ==> [:nodes| nodes  ifNil: [false] ifNotNil: [true] ]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 1/7/2014 11:45'!
onentry
	^ super onentry ==> [:nodes | nodes ifNil: [Array new] ifNotNil: [(nodes at: 3) collect: [:a | a inputValue asSymbol ] ] ]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 1/7/2014 11:45'!
onexit 
	^ super onexit ==> [:nodes |nodes ifNil: [Array new] ifNotNil: [(nodes at: 3) collect: [:a | a inputValue asSymbol ] ] ]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 1/7/2014 11:42'!
regiontype 
	^ super regiontype  ==> [:nodes| Au3Region new: nodes second inputValue]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 2/16/2014 12:32'!
start
	^ super start ==> [:nodes|  | istate errors |
							errors := ''.
							istate := nodes first. 
							nodes allButFirst do: 
								[:substate| |toBeReplaced |
								(toBeReplaced := istate at: substate name1)
									ifNotNil: 	[toBeReplaced elder replaceChild: toBeReplaced  by: substate ] 
									ifNil: 		[errors := errors, 'could not replace ', substate name1, String cr]].
							istate writeTargets.  
							errors := errors,  istate illegalTransitions .
							errors := errors,  istate unknownTargets. 
							errors ifNotEmpty: [istate  := PPFailure message: errors at: 0].
							istate ]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 3/9/2012 20:02'!
state
	^ super state ==> [:nodes| | istate isubstates itransitions|
							istate := nodes second value.
							istate entryActions: (nodes at: 3).
						 	istate exitActions: (nodes at: 4).
							itransitions := (nodes at: 5) ifNil: [Array new].
							itransitions do: [:t|  istate addTransition: t].
							isubstates := (nodes at: 6) ifNil: [Array new].
							isubstates do: [:s| |child| 
										child := s value. 
										istate addChild: child]. 
							istate]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 1/7/2014 11:47'!
transition 
	^ super transition ==> [:nodes | Au3Transition new 
									target: (nodes at: 4) inputValue asSymbol
									event: nodes first inputValue asSymbol
									guards: nodes second
									actions: (nodes at: 5)]! !

!Au3Compiler methodsFor: 'productions' stamp: 'hk 1/7/2014 11:45'!
xortype
	^ super xortype ==> [:nodes| | istate |  
						istate := Au3XorState new: nodes first inputValue.
						istate history: nodes second.
					 	istate]! !

!Au3Grammar class methodsFor: 'compiling' stamp: 'hk 7/23/2010 12:12'!
compile:  aSpec
	^self parse: aSpec onError: [:msg :pos | self error: (msg, ' at: ', pos printString)]! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:27'!
actions
	^($[ asParser , identifier plus , $] asParser ) optional trim:sc		 
	! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:15'!
comment
 	^ $" asParser , (PPPredicateObjectParser anyExceptAnyOf: (String with: $") ) star , $" asParser! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:17'!
guards
	^ ($[ asParser , identifier plus , $] asParser )  optional trim:sc! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:21'!
history
	^ 'history' asParser token optional trim:sc  ! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:16'!
identifier
	^ (#letter asParser , #word asParser star) token trim:sc! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:25'!
onentry
	^( 'onEntry:' asParser , ($[ asParser trim:sc), identifier plus "onEntryActions", $] asParser ) optional trim:sc! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:26'!
onexit	
	^( 'onExit:' asParser, ($[ asParser trim:sc), identifier plus "onExitActions", $] asParser ) optional trim:sc! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:18'!
regiontype
	^ 'r:' asParser, identifier trim:sc! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:16'!
sc
	"parse whitespace and comments"

 	^#space asParser | comment! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:19'!
start
	^ state plus end! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:18'!
state	
	^ $( asParser, (regiontype / xortype), onentry , onexit , transition plus optional, state plus optional trim, $) asParser trim:sc! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 3/9/2012 19:56'!
transition
	^ identifier "event", guards, '->' asParser, identifier "target", actions
	! !

!Au3Grammar methodsFor: 'rules' stamp: 'hk 2/17/2014 21:21'!
xortype
	^ identifier, history ! !

Object subclass: #Au3CodeSize
	instanceVariableNames: 'vars methods loc classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3CodeSize commentStamp: 'hk 5/10/2010 23:39' prior: 0!
I help counting classes, LOC, methods and variables.
I can be added and subtracted.

Instance Variables
	classes:		<Integer>
	loc:			<Integer>
	methods:		<Integer>
	vars:			<Integer>

!

!Au3CodeSize class methodsFor: 'cleaning' stamp: 'hk 3/2/2012 13:30'!
cleanUp
	"Au3Model cleanUp"

	Au3Model subclasses do: [:cls | cls removeCategory: #'sm generated access']

"Au3CodeSize newOn: Au3Model"
"Au3CodeSize newOnWithSubclasses: Au3Grammar"
"Au3CodeSize newOn: Au3Scriptholder"
"Au3CodeSize newOn: (Array with: Au3State with: Au3XorState with: Au3Region with: Au3Transition)"

"Au3CodeSize  newOnCategoryOf:  Au3Model"
"Au3CodeSize  newOnCategoryOf:  Au3TestMachine1"! !

!Au3CodeSize class methodsFor: 'as yet unclassified' stamp: 'hk 5/13/2010 15:24'!
newOn: aClassOrCollectionOfClasses

	| size |
	(aClassOrCollectionOfClasses isKindOf: Class) 
		ifTrue: [^self new sizeOfClass: aClassOrCollectionOfClasses].
	size := self newOn: (aClassOrCollectionOfClasses first).
	aClassOrCollectionOfClasses allButFirst do: [:cls| size + (self newOn: cls)].
	^size! !

!Au3CodeSize class methodsFor: 'as yet unclassified' stamp: 'hk 5/13/2010 14:48'!
newOnCategoryOf: aClass

	^self new sizeOfCategory: aClass! !

!Au3CodeSize class methodsFor: 'as yet unclassified' stamp: 'hk 5/13/2010 14:51'!
newOnSubclassesOf: aClass

	^self new sizeOfSuclassesOf: aClass! !

!Au3CodeSize class methodsFor: 'as yet unclassified' stamp: 'hk 5/19/2010 20:31'!
newOnWithSubclasses: aClass

	| size |
	(aClass isKindOf: Class) ifFalse: [^self error: 'argument is no single class'].
	^(self newOn: aClass) + (self newOnSubclassesOf: aClass)! !

!Au3CodeSize methodsFor: 'arithmetic' stamp: 'hk 5/10/2010 23:42'!
+ anAuCodeSize

	vars := vars + (anAuCodeSize vars).
	methods  := methods + (anAuCodeSize methods).
	loc := loc + (anAuCodeSize loc).
	classes := classes + (anAuCodeSize classes).! !

!Au3CodeSize methodsFor: 'arithmetic' stamp: 'hk 5/10/2010 23:43'!
- anAuCodeSize

	vars := vars - (anAuCodeSize vars).
	methods  := methods - (anAuCodeSize methods).
	loc := loc - (anAuCodeSize loc).
	classes := classes - (anAuCodeSize classes).! !

!Au3CodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 23:42'!
classes
	^classes! !

!Au3CodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:18'!
loc
	^loc! !

!Au3CodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:17'!
methods
	^methods! !

!Au3CodeSize methodsFor: 'printing' stamp: 'hk 5/10/2010 23:47'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: ': ',classes printString, ' Klassen; ', loc printString, ' LOC; ', vars printString, ' Variablen; ', methods printString, ' Methoden'
	! !

!Au3CodeSize methodsFor: 'initialize' stamp: 'hk 6/28/2010 12:25'!
sizeOfCategory: aClass

	loc := vars := methods := classes := 0.
	(SystemOrganization listAtCategoryNamed: aClass category)
		do: [:cls | self + (Au3CodeSize newOn:(Smalltalk at: cls)) ].
! !

!Au3CodeSize methodsFor: 'initialize' stamp: 'hk 5/13/2010 14:46'!
sizeOfClass: aClass

	loc := 0.
	aClass methodsDo: [:m | loc := loc +  (m getSource  asArray select: [:c | c = Character cr]) size].
	aClass class methodsDo: [:m | loc := loc +  (m getSource  asArray select: [:c | c = Character cr]) size].
	vars := ((aClass instVarNames size) + (aClass classVarNames size)).
	methods := ((aClass methodDict size) + (aClass class methodDict size)).
	classes := 1.! !

!Au3CodeSize methodsFor: 'initialize' stamp: 'hk 6/28/2010 12:25'!
sizeOfSuclassesOf: aClass

	loc := vars := methods := classes := 0.
	aClass subclassesDo: [:cls |self + (Au3CodeSize newOn: cls)]! !

!Au3CodeSize methodsFor: 'accessing' stamp: 'hk 5/10/2010 19:17'!
vars
	^vars ! !

Object subclass: #Au3Model
	instanceVariableNames: 'statecharts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3'!

!Au3Model commentStamp: '<historical>' prior: 0!
I am the superclass for a model that uses AuStates. 
My subclasses implement specification methods named '<statename>Spec' for each single state machine. 
They must  ''self create: #aStateName'' in the initialize method for each state defined

Instance Variables
	statecharts:		<Dictionary of AuState>			- the topmost states by their name
						
!

Au3Model subclass: #Au3MicrowaveOven
	instanceVariableNames: 'timer timerEnabled doorClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Examples'!

!Au3MicrowaveOven commentStamp: 'hk 5/11/2010 16:42' prior: 0!
My oven is a state with two parallel Substates for the heater and the door. 
I thus exhibit a hierarchical AuXorState as well as a hierarchical multiState AuState.
My timer is not yet modelled as an independent process.

Instance Variables
	doorClosed:		<Boolean>		- sets the door sub-sm on startup
	timer:			  	<Object>		- not in the sm, can be set, startet and stopped
	timerEnabled: 	<Boolean>	!

!Au3MicrowaveOven class methodsFor: 'example' stamp: 'Hartmut Krasemann 8/15/2010 20:04'!
example
	"Au3MicrowaveOven example"

	| mysm |
	mysm := Au3MicrowaveOven new.	Transcript open; show: mysm oven content.
	mysm openDoor. 					Transcript show: mysm oven content.
	mysm start. 						Transcript show: mysm oven content.
	mysm closeDoor. 					Transcript show: mysm oven content.
	mysm start. 						Transcript show: mysm oven content.
	mysm finish. 						Transcript show: mysm oven content.
	^mysm! !

!Au3MicrowaveOven methodsFor: 'actions' stamp: 'hk 6/10/2010 20:11'!
checkDoor
	"check the door"  
	^doorClosed ifTrue: [self closeDoor] ifFalse: [self openDoor]! !

!Au3MicrowaveOven methodsFor: 'actions' stamp: 'hk 6/11/2010 11:05'!
closeDoor
	self oven process: #close! !

!Au3MicrowaveOven methodsFor: 'sm-actions' stamp: 'hk 5/12/2010 14:53'!
disableTimeSetting
	timerEnabled := false! !

!Au3MicrowaveOven methodsFor: 'sm-actions' stamp: 'hk 7/6/2010 19:37'!
doorIsClosed
	"test the state machine"
	^(self oven at: 'closed') isEntered! !

!Au3MicrowaveOven methodsFor: 'sm-actions' stamp: 'hk 5/12/2010 14:57'!
enableTimeSetting
	timerEnabled := true! !

!Au3MicrowaveOven methodsFor: 'actions' stamp: 'hk 5/12/2010 14:58'!
finish
	self oven process: #finished! !

!Au3MicrowaveOven methodsFor: 'initialize-release' stamp: 'hk 3/3/2012 13:31'!
initialize

	self create: #oven.		"create my statemachines as defined in the sm-specification methods"
	doorClosed := true.
	timerEnabled := false.
	(self statecharts at: #oven) enter.
	self checkDoor
! !

!Au3MicrowaveOven methodsFor: 'actions' stamp: 'hk 5/12/2010 14:51'!
openDoor
	self oven process: #open! !

!Au3MicrowaveOven methodsFor: 'sm generated access' stamp: 'hk 2/17/2014 21:27'!
oven   ^self statecharts at: #oven! !

!Au3MicrowaveOven methodsFor: 'sm-specification' stamp: 'Hartmut Krasemann 8/9/2010 23:18'!
ovenSpec
	"the oven state spec"
^'	(r: oven
		(heater   
			(idle
				onEntry:		[enableTimeSetting]
				onExit:  			[disableTimeSetting]
				start [doorIsClosed] -> cooking )
			(cooking
				onEntry:		[startTimer]
				onExit: 			[stopTimer]
				open -> idle
				finished -> idle ))
		(door
			history
			(open
				close -> closed )				
			(closed
				open -> open)))
'! !

!Au3MicrowaveOven methodsFor: 'actions' stamp: 'hk 5/12/2010 14:51'!
setTime: someSeconds  
	timerEnabled ifTrue: [timer := someSeconds] ifFalse:[self error: 'Timer disabled']! !

!Au3MicrowaveOven methodsFor: 'actions' stamp: 'hk 5/12/2010 14:51'!
start
	self oven process: #start! !

!Au3MicrowaveOven methodsFor: 'sm-actions' stamp: 'hk 5/12/2010 14:57'!
startTimer! !

!Au3MicrowaveOven methodsFor: 'sm-actions' stamp: 'hk 5/12/2010 14:57'!
stopTimer! !

!Au3Model methodsFor: 'initialize-release' stamp: 'hk 3/3/2012 13:31'!
create: aStateName 
	"create and initialize the statechart specified in aSpecSelector,  write the access method"
	
	| spec sm errors aSpecSelector |
	aSpecSelector :=  (aStateName , 'Spec') asSymbol..
	spec := (self perform: aSpecSelector).
	sm := Au3Compiler compile: spec.							"this uses the PetitParser subclasses"
"	sm := Au3Scriptholder createSmFrom: spec.	"				"this uses the PetitParser script"
"	sm := Au3Scriptholder createSameSmFrom: spec.	"			"this uses the alternative parser script with sm !!= state"
	sm  model: self. 
	self statecharts at: (sm name1) put: sm.
	self writeAccessMethod: sm name1! !

!Au3Model methodsFor: 'accessing' stamp: 'hk 3/3/2012 13:31'!
statecharts
	^ statecharts ifNil: [statecharts := Dictionary new]! !

!Au3Model methodsFor: 'private' stamp: 'hk 3/2/2012 12:24'!
writeAccessMethod: aStateName 
	self class compile: (aStateName, '   ^self statecharts at: #' , aStateName) classified: 'sm generated access'! !

Au3Model subclass: #Au3TestMachine1
	instanceVariableNames: 'action1x2 guard eventAction1 eventAction2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3TestMachine1 commentStamp: '<historical>' prior: 0!
Au3TestMachine1 is used for statechart tests 4 levels deep
Instance Variables:
	action1x2	<Boolean>
	guard	<Boolean>!

!Au3TestMachine1 methodsFor: 'sm actions' stamp: 'Hartmut Krasemann 8/4/2010 15:40'!
action1
	eventAction1 := true! !

!Au3TestMachine1 methodsFor: 'accessing' stamp: 'hk 7/14/2010 17:14'!
action1x2
	^action1x2! !

!Au3TestMachine1 methodsFor: 'sm actions' stamp: 'Hartmut Krasemann 8/4/2010 15:40'!
action2
	eventAction2 := true! !

!Au3TestMachine1 methodsFor: 'sm actions' stamp: 'hk 7/14/2010 17:13'!
enter1x2
	action1x2 := true! !

!Au3TestMachine1 methodsFor: 'accessing' stamp: 'Hartmut Krasemann 8/4/2010 15:41'!
eventAction1 
	^eventAction1 ! !

!Au3TestMachine1 methodsFor: 'accessing' stamp: 'Hartmut Krasemann 8/4/2010 15:41'!
eventAction2 
	^eventAction2 ! !

!Au3TestMachine1 methodsFor: 'sm actions' stamp: 'hk 7/14/2010 17:13'!
exit1x2
	action1x2 := false! !

!Au3TestMachine1 methodsFor: 'accessing' stamp: 'hk 6/15/2010 15:20'!
guard: anObject
	guard := anObject! !

!Au3TestMachine1 methodsFor: 'initialization' stamp: 'hk 3/2/2012 12:17'!
initialize
	"super initialize creates the state machines"
	
	self create: #test.
	guard := true.
	action1x2  := false.
	eventAction1 := false.
	eventAction2  := false! !

!Au3TestMachine1 methodsFor: 'sm actions' stamp: 'hk 6/15/2010 15:21'!
isGuarded
	^ guard! !

!Au3TestMachine1 methodsFor: 'sm actions' stamp: 'hk 6/15/2010 15:51'!
isGuardedByDefault
	^ true! !

!Au3TestMachine1 methodsFor: 'sm generated access' stamp: 'hk 2/17/2014 21:27'!
root   ^self statecharts at: #root! !

!Au3TestMachine1 methodsFor: 'sm-specification' stamp: 'Hartmut Krasemann 8/4/2010 15:38'!
testSpec
	"the test state spec"
^' (root 
		(top1
			zz -> top2 [action1 action2]
			(top1x1	
				aa [isGuarded isGuardedByDefault] -> top1x2
				bb -> top2x1	)
			(top1x2	
				onEntry:		[enter1x2]
				onExit:			[exit1x2]
				gg -> top2x2x1 ) )
		(top2
			history
			yy -> top1
			(top2x1
				cc -> top2x2)
			(top2x2	
				history
				dd -> top2x1	
				(top2x2x1
					ee -> top2x2x2)
				(top2x2x2
					ff -> top1x2))))	
'! !

Au3Model subclass: #Au3TestMachine2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3TestMachine2 commentStamp: '<historical>' prior: 0!
Au3TestMachine2 carries a statemachine with regions, 6 levels deep. Used for history tests and region exits!

!Au3TestMachine2 methodsFor: 'initialization' stamp: 'hk 3/2/2012 12:18'!
initialize
	"super initialize creates the state machines"
	
	self create: #test! !

!Au3TestMachine2 methodsFor: 'sm-specification' stamp: 'hk 3/17/2012 18:33'!
testSpec
	"the test state spec"
^'   (world    
		(r: root1   
			zz -> root2
			(top1)
			(top2
				history  
				(top2x1
					c -> top2x2)
				(top2x2	
					history	
					d -> top2x1
					(top2x2x1
						ee -> top2x2x2)
					(top2x2x2))))	
		( root2
			xx -> root1 ))
	(top1
				(r: top1x1)
				(top1x2))
	(r: top1x1		
		aa -> top1x2 
		yy -> root2  
		(top1x1x1
			( top1x1x1x1
				a -> top1x1x1x2)
			( top1x1x1x2))
		( top1x1x2
			( top1x1x2x1)
			( top1x1x2x2)))
'! !

!Au3TestMachine2 methodsFor: 'sm generated access' stamp: 'hk 2/17/2014 21:27'!
world   ^self statecharts at: #world! !

Au3Model subclass: #Au3TestMachine3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3-Tests'!

!Au3TestMachine3 commentStamp: '<historical>' prior: 0!
Au3TestMachine3 is used to test for 
- illegal transitions, 
- illegal TargetNames and
- state Replacement!

!Au3TestMachine3 methodsFor: 'initialization' stamp: 'hk 3/2/2012 12:26'!
initialize	
	self create: #test! !

!Au3TestMachine3 methodsFor: 'sm-specification' stamp: 'hk 9/14/2011 17:30'!
testSpec
	"the test state spec"
^'   (world 
		(r: root1
			zz -> root2
			(top1
				(r: top1x1		
					aa -> top1x2
					bb -> top2x1
					yy -> wrong1
				(top1x1x1
					( top1x1x1x1
						a -> top1x1x1x2)
					( top1x1x1x2))
						( top1x1x2
							( top1x1x2x1)
							( top1x1x2x2)))
				(top1x2	
					gg -> top2x2x1))
			(top2))
		( root2 ) )  
		
( root2
			xx -> root1 )		
(top2
	history
	(top2x1
		c -> wrong2)
	(top2x2 ))

(top2x2	
	history	
	d -> top2x1					
	(top2x2x1
		ee -> top2x2x2)
	(top2x2x2
		ff -> top1x2 ))

'! !

Object subclass: #Au3Scriptholder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3'!

!Au3Scriptholder class methodsFor: 'parser scripts' stamp: 'hk 3/9/2012 19:43'!
createSameSmFrom: aSpec
	"this alternative compiler script using a different grammar (with sm. state & region) comprises 67 LOC"
	
	| sm region twoplusstates state history identifier transition onentry onexit auDSL regiontype xortype guards actions |
	
	state := PPUnresolvedParser new.
	region := PPUnresolvedParser new.
	sm := PPUnresolvedParser new.
	identifier := (#letter asParser , #word asParser star) token trim.
	guards := ($[ asParser, identifier plus, $] asParser ) trim optional ==> 
			[:n | n ifNil: [Array new] ifNotNil: [n second collect: [:g| g value asSymbol]]].
	actions := ($[ asParser , identifier plus , $] asParser ) trim optional ==> 
			[:n | n ifNil: [Array new] ifNotNil: [n second collect: [:a| a value asSymbol]]].
	transition := identifier, guards, '->' asParser, identifier, actions ==> 
			[:nodes | Au3Transition new 	target: (nodes at: 4) 
									value asSymbol 
									event: nodes first value asSymbol 
									guards: (nodes second) 
									actions: (nodes at: 5) ].
	onexit	:= ('onExit:' asParser trim, $[ asParser, identifier plus, $] asParser ) optional ==>
			[:nodes | nodes ifNil: [Array new] ifNotNil: [(nodes at: 3) collect: [:a | a value asSymbol ] ] ] .
	onentry := ('onEntry:' asParser trim, $[ asParser , identifier plus, $] asParser) optional ==> 
			[:nodes | nodes ifNil: [Array new] ifNotNil:  [(nodes at: 3) collect: [:a | a value asSymbol]]] .
	history := ('history' asParser trim) optional ==> [:n | n  ifNil: [false] ifNotNil: [true]].
	twoplusstates := ((region / sm / state), (region / sm / state) plus)  ==> [:n| (Array with: n first), n second].
	state def: 	($( asParser trim, identifier, onentry , onexit , transition star, $) asParser trim) ==>
			[:n | | istate itransitions | 
				(istate := Au3XorState new: n second value)
				 	entryActions: (n at: 3);
			 		exitActions: (n at: 4).
				itransitions := (n at: 5) ifNil: [Array new].
				itransitions do: [:t|  istate addTransition: t].
				istate] .
	sm def:  	($( asParser trim, identifier, history, onentry, onexit, transition star, twoplusstates, $) asParser trim) ==>
			[:n | | istate itransitions isubstates |
				(istate := Au3XorState new: n second value)
					 history: n third;
					 entryActions: (n at: 4);
			 		 exitActions: (n at: 5).
				itransitions := (n at: 6) ifNil: [Array new].
				itransitions do: [:t|  istate addTransition: t].
				isubstates := (n at: 7).
				isubstates do:  [:s| |child| child := s value.  istate addChild: child].
				istate].
	region def: ('(r:' asParser trim, identifier, onentry , onexit , transition star, twoplusstates, $) asParser trim) ==>
			[:n | | istate itransitions isubstates |
				(istate := Au3Region new: n second value)
					 entryActions: (n at: 3);
			 		 exitActions: (n at: 4).
				itransitions := (n at: 5) ifNil: [Array new].
				itransitions do: [:t|  istate addTransition: t].
				(n at: 6) do:  [:s| |child| child := s value. istate addChild: child].
				istate].
	auDSL := (region / sm / state) trim plus end ==> 
			[:nodes|  | istate errors |	errors := ''.
								istate := nodes first.
								nodes allButFirst do: 
									[:substate| |toBeReplaced |
									(toBeReplaced := istate at: substate name1)
										ifNotNil: 	[toBeReplaced elder replaceChild: toBeReplaced  by: substate ] 
										ifNil: 		[errors := errors, 'could not replace ', substate name1, String cr]].
								istate writeTargets.
								errors := errors,  istate illegalTransitions .
								errors := errors,  istate unknownTargets. 
								errors ifNotEmpty: [istate  := PPFailure message: errors at: 0].
								istate ].
	^auDSL parse: aSpec onError: [ :msg :pos | ^ self error: msg printString , ' at: ' , pos printString , ' in ' , aSpec ].! !

!Au3Scriptholder class methodsFor: 'parser scripts' stamp: 'hk 3/9/2012 19:45'!
createSmFrom: aSpec
	"this skript form of the AuCompiler comprises 52 LOC"
	
	| sm region twoplusstates state history identifier transition onentry onexit auDSL regiontype xortype guards actions |
	
	state := PPUnresolvedParser new.
	identifier := (#letter asParser , #word asParser star) token trim.
	guards := ($[ asParser, identifier plus, $] asParser ) trim optional ==> 
			[:n | n ifNil: [Array new] ifNotNil: [n second collect: [:g| g value asSymbol]]].
	actions := ($[ asParser , identifier plus , $] asParser ) trim optional ==> 
			[:n | n ifNil: [Array new] ifNotNil: [n second collect: [:a| a value asSymbol]]].
	transition := identifier, guards, '->' asParser, identifier, actions ==> 
			[:nodes | Au3Transition new 	target: (nodes at: 4) 
									value asSymbol 
									event: nodes first value asSymbol 
									guards: (nodes second) 
									actions: (nodes at: 5) ].
	onexit	:= ('onExit:' asParser trim, $[ asParser, identifier plus, $] asParser ) optional ==>
			[:nodes | nodes ifNil: [Array new] ifNotNil: [(nodes at: 3) collect: [:a | a value asSymbol ] ] ] .
	onentry := ('onEntry:' asParser trim, $[ asParser , identifier plus, $] asParser) optional ==> 
			[:nodes | nodes ifNil: [Array new] ifNotNil:  [(nodes at: 3) collect: [:a | a value asSymbol]]] .
	history := ('history' asParser trim) optional ==> [:n | n  ifNil: [false] ifNotNil: [true]].
	xortype := identifier, history  ==> 
			[:nodes |  | istate |	istate := Au3XorState new: nodes first value.
							istate history: nodes second.
							istate].
	regiontype := 'r:' asParser, identifier ==> [:nodes| Au3Region new: nodes second value].
	state def: 	($( asParser, (regiontype / xortype), onentry, onexit, transition plus optional, state plus optional trim, $) asParser trim) ==>
			[:nodes| | istate isubstates itransitions|
					istate := nodes second value.
					istate entryActions: (nodes at: 3).
				 	istate exitActions: (nodes at: 4).
					itransitions := (nodes at: 5) ifNil: [Array new].
					itransitions do: [:t|  istate addTransition: t].
					isubstates := (nodes at: 6) ifNil: [Array new].
					isubstates do:  [:s| |child| child := s value. istate addChild: child]. 
					istate] .
	auDSL := state trim plus end ==> 
			[:nodes|  | istate errors |
					errors := ''.
					istate := nodes first.
					nodes allButFirst do: 
						[:substate| |toBeReplaced |
						(toBeReplaced := istate at: substate name1)
							ifNotNil: 	[toBeReplaced elder replaceChild: toBeReplaced  by: substate ] 
							ifNil: 		[errors := errors, 'could not replace ', substate name1, String cr]].
					istate writeTargets.
					errors := errors,  istate illegalTransitions .
					errors := errors,  istate unknownTargets. 
					errors ifNotEmpty: [istate  := PPFailure message: errors at: 0].
					istate ].
	^auDSL parse: aSpec onError: [ :msg :pos | ^ self error: msg printString , ' at: ' , pos printString , ' in ' , aSpec ].! !

Object subclass: #Au3State
	instanceVariableNames: 'name log children entryActions exitActions history model elder entered transitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3'!

!Au3State commentStamp: '<historical>' prior: 0!
I am the abstract superclass for a Harel statechart or a state therein
	
Instance Variables
	name:			<String>
	children:			<Set of AuState>					
	elder:			<AuState|nil>		
	transitions:		<Set of AuTransitions>
	entryActions:		<Array of Symbol>
	exitActions:		<Array of Symbol>
	log:				<Collection of String>				- may on day be size limited
	history: 			<Boolean>						- may be true for AuXORStates only
	entered:			<Boolean>
	model:			<AuModel>						- the stateless application that holds my guards and executes my actions!

Au3State subclass: #Au3Region
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3'!

!Au3Region commentStamp: 'hk 7/15/2010 18:18' prior: 0!
I am a Harel statechart or a region therein
	- my children represent parallel states (regions)
	- history is never true!

!Au3Region methodsFor: 'semantics' stamp: 'hk 7/23/2010 15:59'!
enterChildren
	children do: [:c| c enter]! !

!Au3Region methodsFor: 'printing' stamp: 'hk 7/23/2010 16:02'!
printOn: aStream indent: anInt

	aStream nextPutAll: self name1, '.'.
	children do: [:c | c isEntered ifTrue: [aStream cr; tab: anInt. c printOn: aStream indent: (anInt + 1)]]! !

!Au3Region methodsFor: 'printing' stamp: 'Hartmut Krasemann 8/2/2010 17:57'!
printType

	^'Region: '! !

!Au3Region methodsFor: 'semantics' stamp: 'hk 7/15/2010 18:43'!
rememberHistory  "do nothing" ! !

!Au3State class methodsFor: 'instance creation' stamp: 'hk 5/12/2010 19:55'!
new: aName
	^super new initialize: aName! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 3/6/2012 10:53'!
addChild: anAuState
	children add: anAuState.
	anAuState elder: self ! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 6/28/2010 14:30'!
addTransition: anAuTransition
	transitions add: anAuTransition! !

!Au3State methodsFor: 'accessing' stamp: 'hk 7/23/2010 15:07'!
at: aName
	"search in depth. answer the first state with aName"
	
	(aName = self name1) ifTrue: [^self].
	children do: [:c| |r| (r := c at: aName) ifNotNil: [^r]].
	^nil ! !

!Au3State methodsFor: 'accessing' stamp: 'hk 5/12/2010 11:55'!
children
	^ children! !

!Au3State methodsFor: 'processing' stamp: 'hk 3/5/2012 21:43'!
commonAncestorWith: aState 
	"answer the common ancestor of aState with me or nil  (must not be a region)"
	"OptimierungsPotenzial: jeder state hlt neben dem Elter noch eine Liste aller Eltern, die ancestorList"

	| ancestorList cand2 cand1|
	ancestorList := Set new.
	cand1 := aState .
	[cand1 notNil ] whileTrue: [ancestorList add: cand1 . cand1:= cand1 elder].
	cand2 := self.  
	[cand2 notNil  and: [(ancestorList includes: cand2) not] ] whileTrue:  [cand2 := cand2 elder].
	^(cand2 isNil or: [cand2 isXor]) ifTrue: [cand2]  ifFalse: [nil]
! !

!Au3State methodsFor: 'printing' stamp: 'hk 7/23/2010 13:12'!
content
	"prettyprint the statemachime content"

	^String streamContents: [:s | self printOn: s]! !

!Au3State methodsFor: 'accessing' stamp: 'hk 6/13/2010 13:59'!
elder
	^elder ! !

!Au3State methodsFor: 'accessing' stamp: 'hk 6/10/2010 19:31'!
elder: anAuState
	elder := anAuState! !

!Au3State methodsFor: 'semantics' stamp: 'hk 7/23/2010 15:56'!
enter
	entryActions do: [:a| model perform: a].
	entered := true. 
	self enterChildren! !

!Au3State methodsFor: 'semantics' stamp: 'hk 7/15/2010 18:11'!
enterChildren
	self subclassResponsibility ! !

!Au3State methodsFor: 'semantics' stamp: 'hk 7/23/2010 17:07'!
enterUpTo: aState
	"stop entering at the common ancestor aState"
	(self = aState) ifFalse: [self enter. self elder enterUpTo: aState ]! !

!Au3State methodsFor: 'accessing' stamp: 'hk 3/2/2012 13:45'!
enteredChild
	^children detect: [:c| c isEntered] ifNone: [nil]
! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 5/16/2010 15:37'!
entryActions: anArray
	entryActions := anArray! !

!Au3State methodsFor: 'semantics' stamp: 'hk 7/23/2010 15:57'!
exit
	self rememberHistory; exitChildren.
	exitActions do: [:a| model perform: a]. 
	entered := false! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 5/16/2010 15:37'!
exitActions: anArray
	exitActions := anArray! !

!Au3State methodsFor: 'semantics' stamp: 'hk 7/15/2010 18:34'!
exitChildren
	children do: [:c| c isEntered ifTrue: [c exit]]! !

!Au3State methodsFor: 'semantics' stamp: 'hk 7/23/2010 17:07'!
exitUpTo: aState
	"stop exiting at the common ancestor aState"
	(self = aState) ifFalse: [self exit. self elder exitUpTo: aState]! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 6/28/2010 14:33'!
history: aBoolean
	history := aBoolean! !

!Au3State methodsFor: 'creating-parser' stamp: 'Hartmut Krasemann 8/9/2010 09:45'!
illegalTransitions
	
	| aStream |
	aStream := WriteStream with: ''. aStream cr.
	self writeIllegalTransitionsOn: aStream.
	aStream size >1 ifTrue: [^self name1, aStream contents] ifFalse: [^'']! !

!Au3State methodsFor: 'initialize-release' stamp: 'hk 7/15/2010 18:14'!
initialize: aName

	log := OrderedCollection new.
	children := Set new.
	transitions := Set new.
	entered := false.
	history := false.
	name := aName! !

!Au3State methodsFor: 'testing' stamp: 'hk 6/13/2010 14:21'!
isEntered
	^entered! !

!Au3State methodsFor: 'testing' stamp: 'hk 3/2/2012 13:44'!
isXor
	^false! !

!Au3State methodsFor: 'accessing' stamp: 'hk 6/15/2010 14:38'!
log
	^log! !

!Au3State methodsFor: 'printing' stamp: 'hk 6/11/2010 16:51'!
log: aString for: anEvent

	log := '*** ', aString , ' ', anEvent printString. ^nil! !

!Au3State methodsFor: 'accessing' stamp: 'hk 7/6/2010 14:43'!
model: anAuModel
	"set the model recursively"
	
	model := anAuModel.
	transitions do: [:t| t model: anAuModel].
	children do: [:c| c model: anAuModel]! !

!Au3State methodsFor: 'accessing' stamp: 'hk 5/11/2010 16:53'!
name1
	^ name! !

!Au3State methodsFor: 'printing' stamp: 'Hartmut Krasemann 8/15/2010 20:03'!
printOn: aStream 
	"for use in Inspector windows"
	
	aStream nextPutAll: self printType.
	self printOn: aStream indent: 1.
	aStream cr! !

!Au3State methodsFor: 'printing' stamp: 'hk 7/23/2010 12:38'!
printOn: aStream indent: anInt	
	"prettyprint the statechart content"
	self subclassResponsibility ! !

!Au3State methodsFor: 'printing' stamp: 'Hartmut Krasemann 8/2/2010 17:56'!
printType
	
	self subclassResponsibility ! !

!Au3State methodsFor: 'processing' stamp: 'hk 3/2/2012 14:21'!
process: anEvent 
	"answer true if done. the bottom most child (state) or children (region) shall execute only"
	| t done |
	self log: 'received:' for: anEvent.
	done := false.
	children do: [ :c | c isEntered ifTrue: [done := c process: anEvent] ].
	done ifFalse: [	t := self transitionFor: anEvent. 
				t ifNotNil: 	[self switchTo: t target. 
						t executeActions.
						done := true] ].
	^done! !

!Au3State methodsFor: 'semantics' stamp: 'hk 7/15/2010 18:32'!
rememberHistory
	self subclassResponsibility ! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 3/9/2012 16:19'!
replaceChild: oldAuState by: newAuState
	children remove: oldAuState ifAbsent: [self error: 'oldChild not found'].  
	self addChild: newAuState! !

!Au3State methodsFor: 'processing' stamp: 'hk 3/2/2012 16:49'!
switchTo: anotherState 
	"exit a State and all superstates up to the common ancestor and enter anotherState with its ancestors"

	| commonAncestor |
	commonAncestor := self commonAncestorWith: anotherState. 
	self exitUpTo: commonAncestor. 
	anotherState enterUpTo: commonAncestor! !

!Au3State methodsFor: 'processing' stamp: 'Hartmut Krasemann 8/8/2010 18:30'!
transitionFor: anEvent
	"answer the first transition for anEvent. log the reason if none found"
	
	| candidates s|
	(candidates := transitions select: [:t| t event = anEvent])
		ifEmpty: [^self log: 'no transition for' for: anEvent]. 		
	(candidates := candidates select: [:t| t guardsSucceedOn: anEvent])
		ifEmpty: [^self log: 'guards failed for' for: anEvent].
	self log: ('!!',candidates size printString,'!! transition for') for: anEvent.
	^candidates anyOne! !

!Au3State methodsFor: 'creating-parser' stamp: 'Hartmut Krasemann 8/9/2010 09:45'!
unknownTargets
	
	| aStream |
	aStream := WriteStream with: ''. aStream cr.
	self writeUnknownTargetsOn: aStream.
	aStream size >1 ifTrue: [^self name1, aStream contents] ifFalse: [^'']! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 3/2/2012 17:51'!
writeIllegalTransitionsOn: aStream

	transitions do: [:t| (self commonAncestorWith: t target) ifNil:  [aStream nextPutAll: ('transition on ', t event, ' is illegal' ); cr]].
	children do: [:c| c writeIllegalTransitionsOn: aStream]! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 3/2/2012 13:10'!
writeTargets
	self writeTargetsIn: self! !

!Au3State methodsFor: 'creating-parser' stamp: 'hk 3/2/2012 14:02'!
writeTargetsIn: aStatechart
	
	transitions do: [:t| t writeTargetFor: aStatechart].
	children do: [:c| c writeTargetsIn: aStatechart  ]! !

!Au3State methodsFor: 'creating-parser' stamp: 'Hartmut Krasemann 8/4/2010 20:43'!
writeUnknownTargetsOn:  aStream
	transitions do: [:t| t target ifNil:  [aStream nextPutAll: ('target ', t targetName , ' is unknown' ); cr]].
	children do: [:c| c writeUnknownTargetsOn: aStream]! !

Au3State subclass: #Au3XorState
	instanceVariableNames: 'firstChild historyChild'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3'!

!Au3XorState commentStamp: '<historical>' prior: 0!
I am a Harel statechart or a state therein 
	- without children I am a simple state 
	
Instance Variables
	firstChild: 		<AuState|nil>						- entered on enter if history not
	historyChild: 		<AuState|nil>						- entered on enter if notNil and history
 

!

!Au3XorState methodsFor: 'creating' stamp: 'hk 3/2/2012 13:32'!
addChild: anAuState
	children ifEmpty:  [ firstChild := anAuState] .
	super addChild: anAuState! !

!Au3XorState methodsFor: 'semantics' stamp: 'hk 3/2/2012 13:37'!
enterChildren
	"regarding history"
	(firstChild isNil or: [self enteredChild isNil not]) ifTrue: [^self].
	(history and: [historyChild notNil]) 
		ifTrue: [historyChild enter] ifFalse: [firstChild enter]! !

!Au3XorState methodsFor: 'accessing' stamp: 'hk 7/15/2010 19:05'!
historyChild
	^ historyChild! !

!Au3XorState methodsFor: 'testing' stamp: 'hk 6/15/2010 12:35'!
isXor
	^true! !

!Au3XorState methodsFor: 'printing' stamp: 'hk 7/23/2010 16:02'!
printOn: aStream indent: anInt

	aStream nextPutAll: self name1, '.'.
	children do: [:c | c isEntered ifTrue: [c printOn: aStream indent: anInt]]! !

!Au3XorState methodsFor: 'printing' stamp: 'Hartmut Krasemann 8/2/2010 17:57'!
printType

	^'State: '! !

!Au3XorState methodsFor: 'semantics' stamp: 'hk 7/16/2010 09:26'!
rememberHistory
	history ifTrue: [historyChild := self enteredChild]! !

!Au3XorState methodsFor: 'as yet unclassified' stamp: 'hk 3/17/2012 18:36'!
replaceChild: oldAuState by: newAuState

 	super replaceChild: oldAuState by: newAuState.
	(firstChild = oldAuState) ifTrue: [firstChild  := newAuState]! !

Object subclass: #Au3Transition
	instanceVariableNames: 'event target guards model actions targetName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AuDSL3'!

!Au3Transition commentStamp: '<historical>' prior: 0!
I hold all values of a transition incl. the names of the guards and actions.

Instance Variables
	model:		<AuModel>				- the application that executes my actions and tests my guards
	event:		<Symbol>				- that fires me
	guards:		<Array of Symbol>	 	- of guards (domain-predicates)
	target:Name <Symbol> 				- name of target
	target:		<AuState>				- state					
	actions:		<Array of Symbol>	 	- of selectors  (domain-actions )
!

!Au3Transition methodsFor: 'accessing' stamp: 'hk 5/10/2010 17:43'!
event
	^event! !

!Au3Transition methodsFor: 'processing' stamp: 'Hartmut Krasemann 8/4/2010 15:49'!
executeActions
	actions do: [:a | model perform: a]! !

!Au3Transition methodsFor: 'processing' stamp: 'hk 3/2/2012 14:03'!
guardsSucceedOn: anEvent 
	"answer true if all guards on anEvent succeed"
	
	^(event = anEvent) and: [(guards ifNil: [Array new]) allSatisfy: [:g | model perform: g] ]! !

!Au3Transition methodsFor: 'accessing' stamp: 'hk 5/16/2010 13:23'!
model: anAuModel2
	model  := anAuModel2! !

!Au3Transition methodsFor: 'printing' stamp: 'Hartmut Krasemann 8/5/2010 14:44'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: ' #', event, ' -> #', targetName! !

!Au3Transition methodsFor: 'accessing' stamp: 'hk 5/10/2010 11:57'!
target
	^ target! !

!Au3Transition methodsFor: 'initialize-release' stamp: 'Hartmut Krasemann 8/4/2010 20:40'!
target: targetState event: anEvent guards: someGuards actions: someActions
		
	targetName := targetState.
	event := anEvent.
	guards := someGuards.
	actions := someActions ! !

!Au3Transition methodsFor: 'accessing' stamp: 'Hartmut Krasemann 8/4/2010 20:42'!
targetName
	^ targetName ! !

!Au3Transition methodsFor: 'initialize-release' stamp: 'hk 3/2/2012 14:02'!
writeTargetFor: aStatechart
	target := (aStatechart at: targetName)! !
